Index: /LMDZ6/branches/cirrus/libf/misc/readTracFiles_mod.f90
===================================================================
--- /LMDZ6/branches/cirrus/libf/misc/readTracFiles_mod.f90	(revision 5201)
+++ /LMDZ6/branches/cirrus/libf/misc/readTracFiles_mod.f90	(revision 5202)
@@ -1387,324 +1572,927 @@
 
 !==============================================================================================================================
-!================ GET THE VALUE OF A KEY FROM A "keys_type" DERIVED TYPE ; THE RESULT IS THE RETURNED VALUE ===================
-!==============================================================================================================================
-CHARACTER(LEN=maxlen) FUNCTION fgetKeyIdx_s1(itr, keyn, ky, def_val, lerr) RESULT(val)
+!===   INTERNAL FUNCTION: GET THE VALUE OF A KEY FOR "itr"th TRACER FROM A "keys_type" DERIVED TYPE AND RETURN THE RESULT   ===
+!===   IF keyn CONTAINS SEVERAL ELEMENTS, TRY WITH EACH ELEMENT ONE AFTER THE OTHER                                         ===
+!==============================================================================================================================
+CHARACTER(LEN=maxlen) FUNCTION fgetKeyIdx(itr, keyn, ky, lerr) RESULT(val)
   INTEGER,                    INTENT(IN)  :: itr
-  CHARACTER(LEN=*),           INTENT(IN)  :: keyn
+  CHARACTER(LEN=*),           INTENT(IN)  :: keyn(:)
   TYPE(keys_type),            INTENT(IN)  :: ky(:)
-  CHARACTER(LEN=*), OPTIONAL, INTENT(IN)  :: def_val
   LOGICAL,          OPTIONAL, INTENT(OUT) :: lerr
 !------------------------------------------------------------------------------------------------------------------------------
+  INTEGER :: ik
+  LOGICAL :: ler
+  ler = .TRUE.
+  DO ik = 1, SIZE(keyn)
+    CALL getKeyIdx(keyn(ik)); IF(.NOT.ler) EXIT
+  END DO
+  IF(PRESENT(lerr)) lerr = ler
+
+CONTAINS
+
+SUBROUTINE getKeyIdx(keyn)
+  CHARACTER(LEN=*), INTENT(IN) :: keyn
+!------------------------------------------------------------------------------------------------------------------------------
   INTEGER :: iky
-  LOGICAL :: ler
   iky = 0; val = ''
-  IF(.NOT.test(itr <= 0 .OR. itr > SIZE(ky), ler)) iky = strIdx(ky(itr)%key(:), keyn)    !--- Correct index
-  IF(.NOT.test(iky == 0, ler))                     val = ky(itr)%val(iky)                !--- Found key
-  IF(iky == 0) THEN
-    IF(.NOT.test(.NOT.PRESENT(def_val), ler))      val = def_val                         !--- Default value
-  END IF
-  IF(PRESENT(lerr)) lerr = ler
-END FUNCTION fgetKeyIdx_s1
-!==============================================================================================================================
-CHARACTER(LEN=maxlen) FUNCTION fgetKeyNam_s1(tname, keyn, ky, def_val, lerr) RESULT(val)
-  CHARACTER(LEN=*),           INTENT(IN)  :: tname, keyn
-  TYPE(keys_type),            INTENT(IN)  :: ky(:)
-  CHARACTER(LEN=*), OPTIONAL, INTENT(IN)  :: def_val
-  LOGICAL,          OPTIONAL, INTENT(OUT) :: lerr
-!------------------------------------------------------------------------------------------------------------------------------
-  val = fgetKeyIdx_s1(strIdx(ky(:)%name, tname), keyn, ky, def_val, lerr)
-END FUNCTION fgetKeyNam_s1
-!==============================================================================================================================
-FUNCTION fgetKeys(keyn, ky, def_val, lerr) RESULT(val)
-CHARACTER(LEN=maxlen),        ALLOCATABLE :: val(:)
-  CHARACTER(LEN=*),           INTENT(IN)  :: keyn
-  TYPE(keys_type),            INTENT(IN)  :: ky(:)
-  CHARACTER(LEN=*), OPTIONAL, INTENT(IN)  :: def_val
-  LOGICAL,          OPTIONAL, INTENT(OUT) :: lerr
-!------------------------------------------------------------------------------------------------------------------------------
-  LOGICAL :: ler(SIZE(ky))
-  INTEGER :: it
-  val = [(fgetKeyIdx_s1(it, keyn, ky, def_val, ler(it)), it = 1, SIZE(ky))]
-  IF(PRESENT(lerr)) lerr = ANY(ler)
-END FUNCTION fgetKeys
-!==============================================================================================================================
-
-
-!==============================================================================================================================
-!========== GET THE VALUE OF A KEY FROM A "keys_type" DERIVED TYPE ; THE RETURNED VALUE IS THE ERROR CODE        ==============
-!==========  The key "keyn" is searched in: 1)           "ky(:)%name" (if given)                                 ==============
-!==========                                 2)      "tracers(:)%name"                                            ==============
-!==========                                 3) "isotope%keys(:)%name"                                            ==============
-!==========  for the tracer[s] "tname[(:)]" (if given) or all the available tracers from the used set otherwise. ==============
-!==========  The type of the returned value(s) can be string, integer or real, scalar or vector                  ==============
-!==============================================================================================================================
-LOGICAL FUNCTION getKeyByName_s1(keyn, val, tname, ky) RESULT(lerr)
+  ler = itr <= 0 .OR. itr > SIZE(ky); IF(ler) RETURN
+  iky = strIdx(ky(itr)%key(:), keyn)
+  ler = iky == 0;                     IF(ler) RETURN
+  val = ky(itr)%val(iky)
+END SUBROUTINE getKeyIdx
+
+END FUNCTION fgetKeyIdx
+!==============================================================================================================================
+
+
+!==============================================================================================================================
+!===                                          GET KEYS VALUES FROM TRACERS INDICES                                          ===
+!==============================================================================================================================
+!=== TRY TO GET THE KEY NAMED "key" FOR THE "itr"th TRACER IN:                                                              ===
+!===  * ARGUMENT "ky" DATABASE IF SPECIFIED ; OTHERWISE:                                                                    ===
+!===  * IN INTERNAL TRACERS DATABASE "tracers(:)%keys" (IF UNFOUND, IN INTERNAL ISOTOPES DATABASE "isotope%keys(:)")        ===
+!=== THE RETURNED VALUE (STRING, AN INTEGER, A REAL OR A LOGICAL) CAN BE EITHER:                                            ===
+!===  * A SCALAR                                                                                                            ===
+!===  * A VECTOR, WHICH IS THE FOUND VALUE PARSED WITH THE SEPARATOR ","                                                    ===
+!===                                                                                                                        ===
+!=== SYNTAX:       lerr = getKeyByIndex_{sirl}{1m}{1m}1(keyn[(:)], val[(:)], itr[, ky(:)]          [, def][, lDisp])        ===
+!==============================================================================================================================
+!=== IF "itr" IS NOT PRESENT, VALUES FOR ALL THE TRACERS OF THE SELECTED DATABASE ARE STORED IN THE VECTOR "val(:)"         ===
+!=== THE NAME OF THE TRACERS FOUND IN THE EFFECTIVELY USED DATABASE CAN BE RETURNED OPTIONALLY IN "nam(:)"                  ===
+!=== SYNTAX        lerr = getKeyByIndex_{sirl}{1m}mm   (keyn[(:)], val (:)      [, ky(:)][, nam(:)][, def][, lDisp])        ===
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_s111(keyn, val, itr, ky, def, lDisp) RESULT(lerr)
   CHARACTER(LEN=*),          INTENT(IN)  :: keyn
   CHARACTER(LEN=maxlen),     INTENT(OUT) :: val
-  CHARACTER(LEN=*),          INTENT(IN)  :: tname
+  INTEGER,                   INTENT(IN)  :: itr
   TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
-!------------------------------------------------------------------------------------------------------------------------------
-  CHARACTER(LEN=maxlen) :: tnam
-  tnam = strHead(delPhase(tname),'_',.TRUE.)                                             !--- Remove phase and tag
-  IF(PRESENT(ky)) THEN                                                                   !=== KEY FROM "ky"
-               val = fgetKeyNam_s1(tname, keyn, ky,           lerr=lerr)                 !--- "ky" and "tname"
-    IF( lerr ) val = fgetKeyNam_s1(tnam,  keyn, ky,           lerr=lerr)                 !--- "ky" and "tnam"
-  ELSE
-    IF(         .NOT.test(.NOT.ALLOCATED(tracers ), lerr)) lerr = SIZE(tracers ) == 0    !=== KEY FROM "tracers"
-    IF(.NOT.lerr) THEN
-               val = fgetKeyNam_s1(tname, keyn, tracers%keys, lerr=lerr)                 !--- "ky" and "tname"
-      IF(lerr) val = fgetKeyNam_s1(tnam,  keyn, tracers%keys, lerr=lerr)                 !--- "ky" and "tnam"
-    END IF
-    IF(lerr.AND..NOT.test(.NOT.ALLOCATED(isotopes), lerr)) lerr = SIZE(isotopes) == 0    !=== KEY FROM "isotope"
-    IF(.NOT.lerr) THEN
-               val = fgetKeyNam_s1(tname, keyn, isotope%keys, lerr=lerr)                 !--- "ky" and "tname"
-      IF(lerr) val = fgetKeyNam_s1(tnam,  keyn, isotope%keys, lerr=lerr)                 !--- "ky" and "tnam"
-    END IF
+  CHARACTER(LEN=*),OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+  lerr = getKeyByIndex_sm11([keyn], val, itr, ky, def, lDisp)
+END FUNCTION getKeyByIndex_s111
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_i111(keyn, val, itr, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn
+  INTEGER,                   INTENT(OUT) :: val
+  INTEGER,                   INTENT(IN)  :: itr
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  INTEGER,         OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+  lerr = getKeyByIndex_im11([keyn], val, itr, ky, def, lDisp)
+END FUNCTION getKeyByIndex_i111
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_r111(keyn, val, itr, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn
+  REAL   ,                   INTENT(OUT) :: val
+  INTEGER,                   INTENT(IN)  :: itr
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  REAL,            OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+  lerr = getKeyByIndex_rm11([keyn], val, itr, ky, def, lDisp)
+END FUNCTION getKeyByIndex_r111
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_l111(keyn, val, itr, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn
+  LOGICAL,                   INTENT(OUT) :: val
+  INTEGER,                   INTENT(IN)  :: itr
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+  lerr = getKeyByIndex_lm11([keyn], val, itr, ky, def, lDisp)
+END FUNCTION getKeyByIndex_l111
+!==============================================================================================================================
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_sm11(keyn, val, itr, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn(:)
+  CHARACTER(LEN=maxlen),     INTENT(OUT) :: val
+  INTEGER,                   INTENT(IN)  :: itr
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  CHARACTER(LEN=*),OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen) :: s
+  LOGICAL :: lD
+  lD = .TRUE.; IF(PRESENT(lDisp)) lD = lDisp
+  s = 'key "'//TRIM(strStack(keyn, '/'))//'" for tracer nr. '//TRIM(int2str(itr))
+  lerr = .TRUE.
+  IF(lerr .AND. PRESENT(ky))         val = fgetKey(ky)                                   !--- "ky"
+  IF(lerr .AND. ALLOCATED (tracers)) val = fgetKey(tracers(:)%keys)                      !--- "tracers"
+  IF(lerr .AND. ASSOCIATED(isotope)) val = fgetKey(isotope%keys(:))                      !--- "isotope"
+  IF(lerr .AND. PRESENT(def)) THEN
+     val = def; lerr = .NOT.PRESENT(def)
+     CALL msg('Using defaut value of '//TRIM(s)//': '//TRIM(def), modname, lD)
   END IF
-END FUNCTION getKeyByName_s1
-!==============================================================================================================================
-LOGICAL FUNCTION getKeyByName_s1m(keyn, val, tname, ky) RESULT(lerr)
+  CALL msg('No '//TRIM(s)//' or out of bounds index', modname, lD .AND. lerr)
+
+CONTAINS
+
+CHARACTER(LEN=maxlen) FUNCTION fgetKey(ky) RESULT(val)
+  TYPE(keys_type),  INTENT(IN)  :: ky(:)
+  lerr = SIZE(ky) == 0; IF(lerr) RETURN
+  val = fgetKeyIdx(itr, keyn(:), ky, lerr)
+END FUNCTION fgetKey
+
+END FUNCTION getKeyByIndex_sm11
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_im11(keyn, val, itr, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn(:)
+  INTEGER,                   INTENT(OUT) :: val
+  INTEGER,                   INTENT(IN)  :: itr
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  INTEGER,         OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen) :: sval, s
+  IF(     PRESENT(def)) lerr = getKeyByIndex_sm11(keyn, sval, itr, ky, int2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByIndex_sm11(keyn, sval, itr, ky, lDisp=lDisp)
+  IF(lerr) RETURN
+  val = str2int(sval)
+  lerr = val == -HUGE(1)
+  s = 'key "'//TRIM(strStack(keyn, '/'))//'" of tracer nr. '//TRIM(int2str(itr))//' is not'
+  CALL msg(TRIM(s)//' an integer: '//TRIM(sval), modname, lerr)
+END FUNCTION getKeyByIndex_im11
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_rm11(keyn, val, itr, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn(:)
+  REAL   ,                   INTENT(OUT) :: val
+  INTEGER,                   INTENT(IN)  :: itr
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  REAL,            OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen) :: sval, s
+  IF(     PRESENT(def)) lerr = getKeyByIndex_sm11(keyn, sval, itr, ky, real2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByIndex_sm11(keyn, sval, itr, ky, lDisp=lDisp)
+  IF(lerr) RETURN
+  val = str2real(sval)
+  lerr = val == -HUGE(1.)
+  s = 'key "'//TRIM(strStack(keyn, '/'))//'" of tracer nr. '//TRIM(int2str(itr))//' is not'
+  CALL msg(TRIM(s)//' a real: '//TRIM(sval), modname, lerr)
+END FUNCTION getKeyByIndex_rm11
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_lm11(keyn, val, itr, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn(:)
+  LOGICAL,                   INTENT(OUT) :: val
+  INTEGER,                   INTENT(IN)  :: itr
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen) :: sval, s
+  INTEGER               :: ival
+  IF(     PRESENT(def)) lerr = getKeyByIndex_sm11(keyn, sval, itr, ky, bool2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByIndex_sm11(keyn, sval, itr, ky, lDisp=lDisp)
+  IF(lerr) RETURN
+  ival = str2bool(sval)
+  lerr = ival == -1
+  s = 'key "'//TRIM(strStack(keyn, '/'))//'" of tracer nr. '//TRIM(int2str(itr))//' is not'
+  CALL msg(TRIM(s)//' a boolean: '//TRIM(sval), modname, lerr)
+  IF(.NOT.lerr) val = ival == 1
+END FUNCTION getKeyByIndex_lm11
+!==============================================================================================================================
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_s1m1(keyn, val, itr, ky, def, lDisp) RESULT(lerr)
   CHARACTER(LEN=*),                   INTENT(IN)  :: keyn
   CHARACTER(LEN=maxlen), ALLOCATABLE, INTENT(OUT) :: val(:)
-  CHARACTER(LEN=*),                   INTENT(IN)  :: tname
+  INTEGER,                            INTENT(IN)  :: itr
   TYPE(keys_type),          OPTIONAL, INTENT(IN)  :: ky(:)
+  CHARACTER(LEN=*),         OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,                  OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen)              :: sval
+  lerr = getKeyByIndex_sm11([keyn], sval, itr, ky, def, lDisp); IF(lerr) RETURN
+  lerr = strParse(sval, ',', val)
+  IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
+END FUNCTION getKeyByIndex_s1m1
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_i1m1(keyn, val, itr, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn
+  INTEGER,      ALLOCATABLE, INTENT(OUT) :: val(:)
+  INTEGER,                   INTENT(IN)  :: itr
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  INTEGER,         OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen)              :: sval, s
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: svals(:)
+  IF(     PRESENT(def)) lerr = getKeyByIndex_sm11([keyn], sval, itr, ky, int2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByIndex_sm11([keyn], sval, itr, ky, lDisp=lDisp)
+  IF(lerr) RETURN
+  lerr = strParse(sval, ',', svals)
+  IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
+  val = str2int(svals)
+  lerr = ANY(val == -HUGE(1))
+  s = 'key "'//TRIM(keyn)//'" of tracer nr. '//TRIM(int2str(itr))//' is not'
+  CALL msg(TRIM(s)//' an integer: '//TRIM(sval), modname, lerr)
+END FUNCTION getKeyByIndex_i1m1
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_r1m1(keyn, val, itr, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn
+  REAL,         ALLOCATABLE, INTENT(OUT) :: val(:)
+  INTEGER,                   INTENT(IN)  :: itr
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  REAL,            OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen)              :: sval, s
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: svals(:)
+  IF(     PRESENT(def)) lerr = getKeyByIndex_sm11([keyn], sval, itr, ky, real2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByIndex_sm11([keyn], sval, itr, ky, lDisp=lDisp)
+  lerr = strParse(sval, ',', svals)
+  IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
+  val = str2real(svals)
+  lerr = ANY(val == -HUGE(1.))
+  s = 'key "'//TRIM(keyn)//'" of tracer nr. '//TRIM(int2str(itr))//' is not'
+  CALL msg(TRIM(s)//' a real: '//TRIM(sval), modname, lerr)
+END FUNCTION getKeyByIndex_r1m1
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_l1m1(keyn, val, itr, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn
+  LOGICAL,      ALLOCATABLE, INTENT(OUT) :: val(:)
+  INTEGER,                   INTENT(IN)  :: itr
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen)              :: sval, s
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: svals(:)
+  INTEGER,               ALLOCATABLE :: ivals(:)
+  IF(     PRESENT(def)) lerr = getKeyByIndex_sm11([keyn], sval, itr, ky, bool2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByIndex_sm11([keyn], sval, itr, ky, lDisp=lDisp)
+  lerr = strParse(sval, ',', svals)
+  IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
+  ivals = str2bool(svals)
+  lerr = ANY(ivals == -1)
+  s = 'key "'//TRIM(keyn)//'" of tracer nr. '//TRIM(int2str(itr))//' is not'
+  CALL msg(TRIM(s)//' a boolean: '//TRIM(sval), modname, lerr)
+  IF(.NOT.lerr) val = ivals == 1
+END FUNCTION getKeyByIndex_l1m1
+!==============================================================================================================================
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_smm1(keyn, val, itr, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),                   INTENT(IN)  :: keyn(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE, INTENT(OUT) :: val(:)
+  INTEGER,                            INTENT(IN)  :: itr
+  TYPE(keys_type),          OPTIONAL, INTENT(IN)  :: ky(:)
+  CHARACTER(LEN=*),         OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,                  OPTIONAL, INTENT(IN)  :: lDisp
 !------------------------------------------------------------------------------------------------------------------------------
   CHARACTER(LEN=maxlen) :: sval
-  lerr = getKeyByName_s1(keyn, sval, tname, ky)
-  IF(test(fmsg('missing key "'//TRIM(keyn)//'" for tracer "'//TRIM(tname)//'"', modname, lerr), lerr)) RETURN
+  lerr = getKeyByIndex_sm11(keyn, sval, itr, ky, def, lDisp); IF(lerr) RETURN
   lerr = strParse(sval, ',', val)
-END FUNCTION getKeyByName_s1m
-!==============================================================================================================================
-LOGICAL FUNCTION getKeyByName_sm(keyn, val, tname, ky, nam) RESULT(lerr)
+  IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
+END FUNCTION getKeyByIndex_smm1
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_imm1(keyn, val, itr, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn(:)
+  INTEGER,      ALLOCATABLE, INTENT(OUT) :: val(:)
+  INTEGER,                   INTENT(IN)  :: itr
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  INTEGER,         OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen)              :: sval, s
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: svals(:)
+  IF(     PRESENT(def)) lerr = getKeyByIndex_sm11(keyn, sval, itr, ky, int2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByIndex_sm11(keyn, sval, itr, ky, lDisp=lDisp)
+  IF(lerr) RETURN
+  lerr = strParse(sval, ',', svals)
+  IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
+  val = str2int(svals)
+  lerr = ANY(val == -HUGE(1))
+  s = 'key "'//TRIM(strStack(keyn, '/'))//'" of tracer nr. '//TRIM(int2str(itr))//' is not'
+  CALL msg(TRIM(s)//' an integer: '//TRIM(sval), modname, lerr)
+END FUNCTION getKeyByIndex_imm1
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_rmm1(keyn, val, itr, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn(:)
+  REAL,         ALLOCATABLE, INTENT(OUT) :: val(:)
+  INTEGER,                   INTENT(IN)  :: itr
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  REAL,            OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen)              :: sval, s
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: svals(:)
+  IF(     PRESENT(def)) lerr = getKeyByIndex_sm11(keyn, sval, itr, ky, real2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByIndex_sm11(keyn, sval, itr, ky, lDisp=lDisp)
+  IF(lerr) RETURN
+  lerr = strParse(sval, ',', svals)
+  IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
+  val = str2real(svals)
+  lerr = ANY(val == -HUGE(1.))
+  s = 'key "'//TRIM(strStack(keyn, '/'))//'" of tracer nr. '//TRIM(int2str(itr))//' is not'
+  CALL msg(TRIM(s)//' a real: '//TRIM(sval), modname, lerr)
+END FUNCTION getKeyByIndex_rmm1
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_lmm1(keyn, val, itr, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn(:)
+  LOGICAL,      ALLOCATABLE, INTENT(OUT) :: val(:)
+  INTEGER,                   INTENT(IN)  :: itr
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen)              :: sval, s
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: svals(:)
+  INTEGER,               ALLOCATABLE :: ivals(:)
+  IF(     PRESENT(def)) lerr = getKeyByIndex_sm11(keyn, sval, itr, ky, bool2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByIndex_sm11(keyn, sval, itr, ky, lDisp=lDisp)
+  IF(lerr) RETURN
+  lerr = strParse(sval, ',', svals)
+  IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
+  ivals = str2bool(svals)
+  lerr = ANY(ivals == -1)
+  s = 'key "'//TRIM(strStack(keyn, '/'))//'" of tracer nr. '//TRIM(int2str(itr))//' is not'
+  CALL msg(TRIM(s)//' a boolean: '//TRIM(sval), modname, lerr)
+  IF(.NOT.lerr) val = ivals == 1
+END FUNCTION getKeyByIndex_lmm1
+!==============================================================================================================================
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_s1mm(keyn, val, ky, nam, def, lDisp) RESULT(lerr)
   CHARACTER(LEN=*),                             INTENT(IN)  :: keyn
   CHARACTER(LEN=maxlen),           ALLOCATABLE, INTENT(OUT) :: val(:)
-  CHARACTER(LEN=*),                             INTENT(IN)  :: tname(:)
-  TYPE(keys_type),       OPTIONAL, TARGET,      INTENT(IN)  :: ky(:)
+  TYPE(keys_type),       OPTIONAL,              INTENT(IN)  ::  ky(:)
   CHARACTER(LEN=maxlen), OPTIONAL, ALLOCATABLE, INTENT(OUT) :: nam(:)
-!------------------------------------------------------------------------------------------------------------------------------
-  TYPE(keys_type), POINTER ::  keys(:)
-  LOGICAL :: lk, lt, li
-  INTEGER :: iq, nq
-
-  !--- DETERMINE THE DATABASE TO BE USED (ky, tracers or isotope)
-  lk = PRESENT(ky)
-  lt = .NOT.lk .AND. ALLOCATED(tracers);  IF(lt) lt = SIZE(tracers)  /= 0; IF(lt) lt = ANY(tracers(1)%keys%key(:) == keyn)
-  li = .NOT.lt .AND. ALLOCATED(isotopes); IF(li) li = SIZE(isotopes) /= 0; IF(li) li = ANY(isotope%keys(1)%key(:) == keyn)
-
-  !--- LINK "keys" TO THE RIGHT DATABASE
-  IF(test(.NOT.ANY([lk,lt,li]), lerr)) RETURN
-  IF(lk) keys => ky(:)
-  IF(lt) keys => tracers(:)%keys
-  IF(li) keys => isotope%keys(:)
-
-  !--- GET THE DATA
-  nq = SIZE(tname)
-  ALLOCATE(val(nq))
-  lerr = ANY([(getKeyByName_s1(keyn, val(iq), tname(iq), keys(:)), iq=1, nq)])
-  IF(PRESENT(nam)) nam = tname(:)
-
-END FUNCTION getKeyByName_sm
-!==============================================================================================================================
-LOGICAL FUNCTION getKey_sm(keyn, val, ky, nam) RESULT(lerr)
+  CHARACTER(LEN=*),      OPTIONAL,              INTENT(IN)  :: def
+  LOGICAL,               OPTIONAL,              INTENT(IN)  :: lDisp
+  lerr = getKeyByIndex_smmm([keyn], val, ky, nam, def, lDisp)
+END FUNCTION getKeyByIndex_s1mm
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_i1mm(keyn, val, ky, nam, def, lDisp) RESULT(lerr)
   CHARACTER(LEN=*),                             INTENT(IN)  :: keyn
-  CHARACTER(LEN=maxlen),           ALLOCATABLE, INTENT(OUT) :: val(:)
-  TYPE(keys_type),       OPTIONAL,              INTENT(IN)  :: ky(:)
+  INTEGER,                         ALLOCATABLE, INTENT(OUT) :: val(:)
+  TYPE(keys_type),       OPTIONAL,              INTENT(IN)  ::  ky(:)
   CHARACTER(LEN=maxlen), OPTIONAL, ALLOCATABLE, INTENT(OUT) :: nam(:)
-!------------------------------------------------------------------------------------------------------------------------------
-! Note: if names are repeated, getKeyByName_sm can't be used ; this routine, using indexes, must be used instead.
-  IF(PRESENT(ky)) THEN                                                                   !=== KEY FROM "ky"
-    val = fgetKeys(keyn, ky, lerr=lerr)
-    IF(PRESENT(nam)) nam = ky(:)%name
-  ELSE
-    IF(         .NOT.test(.NOT.ALLOCATED(tracers ), lerr)) lerr = SIZE(tracers ) == 0    !=== KEY FROM "tracers"
-    IF(.NOT.lerr) val = fgetKeys(keyn, tracers%keys, lerr=lerr)
-    IF(.NOT.lerr.AND.PRESENT(nam)) nam = tracers(:)%keys%name
-    IF(lerr.AND..NOT.test(.NOT.ALLOCATED(isotopes), lerr)) lerr = SIZE(isotopes) == 0    !=== KEY FROM "isotope"
-    IF(.NOT.lerr) val = fgetKeys(keyn, isotope%keys, lerr=lerr)
-    IF(.NOT.lerr.AND.PRESENT(nam)) nam = isotope%keys(:)%name
+  INTEGER,               OPTIONAL,              INTENT(IN)  :: def
+  LOGICAL,               OPTIONAL,              INTENT(IN)  :: lDisp
+  lerr = getKeyByIndex_immm([keyn], val, ky, nam, def, lDisp)
+END FUNCTION getKeyByIndex_i1mm
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_r1mm(keyn, val, ky, nam, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),                             INTENT(IN)  :: keyn
+  REAL,                            ALLOCATABLE, INTENT(OUT) :: val(:)
+  TYPE(keys_type),       OPTIONAL,              INTENT(IN)  ::  ky(:)
+  CHARACTER(LEN=maxlen), OPTIONAL, ALLOCATABLE, INTENT(OUT) :: nam(:)
+  REAL,                  OPTIONAL,              INTENT(IN)  :: def
+  LOGICAL,               OPTIONAL,              INTENT(IN)  :: lDisp
+  lerr = getKeyByIndex_rmmm([keyn], val, ky, nam, def, lDisp)
+END FUNCTION getKeyByIndex_r1mm
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_l1mm(keyn, val, ky, nam, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),                             INTENT(IN)  :: keyn
+  LOGICAL,                         ALLOCATABLE, INTENT(OUT) :: val(:)
+  TYPE(keys_type),       OPTIONAL,              INTENT(IN)  ::  ky(:)
+  CHARACTER(LEN=maxlen), OPTIONAL, ALLOCATABLE, INTENT(OUT) :: nam(:)
+  LOGICAL,               OPTIONAL,              INTENT(IN)  :: def
+  LOGICAL,               OPTIONAL,              INTENT(IN)  :: lDisp
+  lerr = getKeyByIndex_lmmm([keyn], val, ky, nam, def, lDisp)
+END FUNCTION getKeyByIndex_l1mm
+!==============================================================================================================================
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_smmm(keyn, val, ky, nam, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),                             INTENT(IN)  :: keyn(:)
+  CHARACTER(LEN=maxlen),           ALLOCATABLE, INTENT(OUT) ::  val(:)
+  TYPE(keys_type),       OPTIONAL,              INTENT(IN)  ::   ky(:)
+  CHARACTER(LEN=maxlen), OPTIONAL, ALLOCATABLE, INTENT(OUT) ::  nam(:)
+  CHARACTER(LEN=*),      OPTIONAL,              INTENT(IN)  ::  def
+  LOGICAL,               OPTIONAL,              INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen) :: s
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: tname(:)
+  INTEGER :: iq, nq(3), k
+  LOGICAL :: lD, l(3)
+  lD = .TRUE.; IF(PRESENT(lDisp)) lD = lDisp
+  s = 'key "'//TRIM(strStack(keyn, '/'))//'"'
+  lerr = .TRUE.
+  IF(PRESENT(ky)) THEN;                 val = fgetKey(ky)                                !--- "ky"
+  ELSE IF(ALLOCATED(tracers)) THEN;     val = fgetKey(tracers(:)%keys)                   !--- "tracers"
+     IF(lerr .AND. ASSOCIATED(isotope)) val = fgetKey(isotope%keys(:))                   !--- "isotope"
   END IF
-END FUNCTION getKey_sm
-!==============================================================================================================================
-LOGICAL FUNCTION getKeyByName_i1(keyn, val, tname, ky) RESULT(lerr)
-  CHARACTER(LEN=*),          INTENT(IN)  :: keyn
-  INTEGER,                   INTENT(OUT) :: val
-  CHARACTER(LEN=*),          INTENT(IN)  :: tname
-  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
-!------------------------------------------------------------------------------------------------------------------------------
-  CHARACTER(LEN=maxlen) :: sval
-  INTEGER :: ierr
-  lerr = getKeyByName_s1(keyn, sval, tname, ky)
-  IF(test(fmsg('key "'//TRIM(keyn)//'" or tracer "'//TRIM(tname)//'" is missing', modname, lerr), lerr)) RETURN
-  READ(sval, *, IOSTAT=ierr) val
-  IF(test(fmsg('key "'//TRIM(keyn)//'" of tracer "'//TRIM(tname)//'" is not an integer', modname, ierr/=0), lerr)) RETURN
-END FUNCTION getKeyByName_i1
-!==============================================================================================================================
-LOGICAL FUNCTION getKeyByName_i1m(keyn, val, tname, ky) RESULT(lerr)
-  CHARACTER(LEN=*),          INTENT(IN)  :: keyn
-  INTEGER,      ALLOCATABLE, INTENT(OUT) :: val(:)
-  CHARACTER(LEN=*),          INTENT(IN)  :: tname
-  TYPE(keys_type), OPTIONAL, INTENT(IN)  ::  ky(:)
-!------------------------------------------------------------------------------------------------------------------------------
-  CHARACTER(LEN=maxlen), ALLOCATABLE :: sval(:)
-  INTEGER :: ierr, iq, nq
-  IF(test(getKeyByName_s1m(keyn, sval, tname, ky), lerr)) RETURN
-  nq = SIZE(sval); ALLOCATE(val(nq))
-  lerr = .FALSE.; DO iq=1, nq; READ(sval(iq), *, IOSTAT=ierr) val(iq); lerr = lerr .OR. ierr /= 0; END DO
-  IF(test(fmsg('key "'//TRIM(keyn)//'" of tracer "'//TRIM(tname)//'" is not an integer', modname, lerr), lerr)) RETURN
-END FUNCTION getKeyByName_i1m
-!==============================================================================================================================
-LOGICAL FUNCTION getKeyByName_im(keyn, val, tname, ky, nam) RESULT(lerr)
-  CHARACTER(LEN=*),                             INTENT(IN)  ::  keyn
-  INTEGER,                         ALLOCATABLE, INTENT(OUT) ::   val(:)
-  CHARACTER(LEN=*),                             INTENT(IN)  :: tname(:)
-  TYPE(keys_type),       OPTIONAL,              INTENT(IN)  ::    ky(:)
-  CHARACTER(LEN=maxlen), OPTIONAL, ALLOCATABLE, INTENT(OUT) ::   nam(:)
-!------------------------------------------------------------------------------------------------------------------------------
-  CHARACTER(LEN=maxlen), ALLOCATABLE :: sval(:), names(:)
-  INTEGER :: ierr, iq, nq
-  IF(test(getKeyByName_sm(keyn, sval, tname, ky, names), lerr)) RETURN
-  nq = SIZE(sval); ALLOCATE(val(nq))
-  DO iq = 1, nq                                                      !--- CONVERT THE KEYS TO INTEGERS
-    READ(sval(iq), *, IOSTAT=ierr) val(iq)
-    IF(test(fmsg('key "'//TRIM(keyn)//'" of tracer "'//TRIM(names(iq))//'" is not an integer', modname, ierr/=0), lerr)) RETURN
-  END DO
-  IF(PRESENT(nam)) nam = names(:)
-END FUNCTION getKeyByName_im
-!==============================================================================================================================
-LOGICAL FUNCTION getKey_im(keyn, val, ky, nam) RESULT(lerr)
-  CHARACTER(LEN=*),                             INTENT(IN)  :: keyn
+  IF(.NOT.lerr) THEN; IF(PRESENT(nam)) nam = tname; RETURN; END IF
+  IF(.NOT.PRESENT(def)) THEN; CALL msg('No '//TRIM(s)//' found', modname, lD); RETURN; END IF
+
+  !--- DEFAULT VALUE
+  l = [PRESENT(ky), ALLOCATED(tracers), ASSOCIATED(isotope)]; nq(:) = 0
+  IF(l(1)) nq(1) = SIZE(ky)
+  IF(l(2)) nq(2) = SIZE(tracers)
+  IF(l(3)) nq(3) = SIZE(isotope%keys)
+  DO k = 1, 3; IF(l(k) .AND. nq(k) /= 0) THEN; val = [(def, iq = 1, nq(k))]; EXIT; END IF; END DO
+  lerr = k == 4
+  CALL msg('Using defaut value for '//TRIM(s)//': '//TRIM(def), modname, lD .AND. .NOT.lerr)
+  CALL msg('No '//TRIM(s), modname, lD .AND. lerr)
+
+CONTAINS
+
+FUNCTION fgetKey(ky) RESULT(val)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: val(:)
+  TYPE(keys_type),       INTENT(IN)  :: ky(:)
+  LOGICAL :: ler(SIZE(ky))
+  INTEGER :: iq
+  lerr = SIZE(ky) == 0; IF(lerr) RETURN
+  tname = ky%name
+  val = [(fgetKeyIdx(iq, keyn(:), ky, ler(iq)), iq = 1, SIZE(ky))]
+  lerr = ANY(ler)
+END FUNCTION fgetKey
+
+END FUNCTION getKeyByIndex_smmm
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_immm(keyn, val, ky, nam, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),                             INTENT(IN)  :: keyn(:)
   INTEGER,                         ALLOCATABLE, INTENT(OUT) ::  val(:)
   TYPE(keys_type),       OPTIONAL,              INTENT(IN)  ::   ky(:)
   CHARACTER(LEN=maxlen), OPTIONAL, ALLOCATABLE, INTENT(OUT) ::  nam(:)
-!------------------------------------------------------------------------------------------------------------------------------
-  CHARACTER(LEN=maxlen), ALLOCATABLE :: sval(:), names(:)
-  INTEGER :: ierr, iq, nq
-  IF(test(getKey_sm(keyn, sval, ky, names), lerr)) RETURN
-  nq = SIZE(sval); ALLOCATE(val(nq))
-  DO iq = 1, nq
-    READ(sval(iq), *, IOSTAT=ierr) val(iq)
-    IF(test(fmsg('key "'//TRIM(keyn)//'" of tracer "'//TRIM(names(iq))//'" is not an integer', modname, ierr/=0), lerr)) RETURN
-  END DO
-  IF(PRESENT(nam)) nam = names
-END FUNCTION getKey_im
-!==============================================================================================================================
-LOGICAL FUNCTION getKeyByName_r1(keyn, val, tname, ky) RESULT(lerr)
-  CHARACTER(LEN=*),          INTENT(IN)  :: keyn
-  REAL,                      INTENT(OUT) :: val
-  CHARACTER(LEN=*),          INTENT(IN)  :: tname
-  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
-!------------------------------------------------------------------------------------------------------------------------------
-  CHARACTER(LEN=maxlen) :: sval
-  INTEGER :: ierr
-  lerr = getKeyByName_s1(keyn, sval, tname, ky)
-  IF(test(fmsg('key "'//TRIM(keyn)//'" or tracer "'//TRIM(tname)//'" is missing',    modname, lerr), lerr)) RETURN
-  READ(sval, *, IOSTAT=ierr) val
-  IF(test(fmsg('key "'//TRIM(keyn)//'" of tracer "'//TRIM(tname)//'" is not a real', modname, ierr/=0), lerr)) RETURN
-END FUNCTION getKeyByName_r1
-!==============================================================================================================================
-LOGICAL FUNCTION getKeyByName_r1m(keyn, val, tname, ky) RESULT(lerr)
-  CHARACTER(LEN=*),           INTENT(IN)  :: keyn
-  REAL,          ALLOCATABLE, INTENT(OUT) :: val(:)
-  CHARACTER(LEN=*),           INTENT(IN)  :: tname
-  TYPE(keys_type),  OPTIONAL, INTENT(IN)  ::  ky(:)
-!------------------------------------------------------------------------------------------------------------------------------
-  CHARACTER(LEN=maxlen), ALLOCATABLE :: sval(:)
-  INTEGER :: ierr, iq, nq
-  IF(test(getKeyByName_s1m(keyn, sval, tname, ky), lerr)) RETURN
-  nq = SIZE(sval); ALLOCATE(val(nq))
-  lerr = .FALSE.; DO iq=1, nq; READ(sval(iq), *, IOSTAT=ierr) val(iq); lerr = lerr .OR. ierr /= 0; END DO
-  IF(test(fmsg('key "'//TRIM(keyn)//'" of tracer "'//TRIM(tname)//'" is not a vector of reals', modname, lerr), lerr)) RETURN
-END FUNCTION getKeyByName_r1m
-!==============================================================================================================================
-LOGICAL FUNCTION getKeyByName_rm(keyn, val, tname, ky, nam) RESULT(lerr)
-  CHARACTER(LEN=*),                             INTENT(IN)  ::  keyn
-  REAL,                            ALLOCATABLE, INTENT(OUT) ::   val(:)
-  CHARACTER(LEN=*),                             INTENT(IN)  :: tname(:)
-  TYPE(keys_type),       OPTIONAL,              INTENT(IN)  ::    ky(:)
-  CHARACTER(LEN=maxlen), OPTIONAL, ALLOCATABLE, INTENT(OUT) ::   nam(:)
-!------------------------------------------------------------------------------------------------------------------------------
-  CHARACTER(LEN=maxlen), ALLOCATABLE :: sval(:), names(:)
-  INTEGER :: ierr, iq, nq
-  IF(test(getKeyByName_sm(keyn, sval, tname, ky, names), lerr)) RETURN
-  nq = SIZE(sval); ALLOCATE(val(nq))
-  DO iq = 1, nq                                                      !--- CONVERT THE KEYS TO INTEGERS
-    READ(sval(iq), *, IOSTAT=ierr) val(iq)
-    IF(test(fmsg('key "'//TRIM(keyn)//'" of tracer "'//TRIM(names(iq))//'" is not a real', modname, ierr/=0), lerr)) RETURN
-  END DO
-  IF(PRESENT(nam)) nam = names
-END FUNCTION getKeyByName_rm
-!==============================================================================================================================
-LOGICAL FUNCTION getKey_rm(keyn, val, ky, nam) RESULT(lerr)
-  CHARACTER(LEN=*),                             INTENT(IN)  :: keyn
+  INTEGER,               OPTIONAL,              INTENT(IN)  ::  def
+  LOGICAL,               OPTIONAL,              INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen) :: s
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: svals(:), tname(:)
+  LOGICAL,               ALLOCATABLE ::    ll(:)
+  IF(     PRESENT(def)) lerr = getKeyByIndex_smmm(keyn, svals, ky, tname, int2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByIndex_smmm(keyn, svals, ky, tname, lDisp=lDisp)
+  IF(lerr) RETURN
+  val = str2int(svals)
+  ll = val == -HUGE(1)
+  lerr = ANY(ll); IF(.NOT.lerr) THEN; IF(PRESENT(nam)) nam = tname; RETURN; END IF
+  s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(strStack(PACK(tname, MASK=ll)))//' is not'
+  CALL msg(TRIM(s)//' an integer: '//TRIM(strStack(svals, MASK=ll)), modname, lerr)
+  IF(.NOT.lerr .AND. PRESENT(nam)) nam = tname
+END FUNCTION getKeyByIndex_immm
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_rmmm(keyn, val, ky, nam, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),                             INTENT(IN)  :: keyn(:)
   REAL,                            ALLOCATABLE, INTENT(OUT) ::  val(:)
   TYPE(keys_type),       OPTIONAL,              INTENT(IN)  ::   ky(:)
   CHARACTER(LEN=maxlen), OPTIONAL, ALLOCATABLE, INTENT(OUT) ::  nam(:)
-!------------------------------------------------------------------------------------------------------------------------------
-  CHARACTER(LEN=maxlen), ALLOCATABLE :: sval(:), names(:)
-  INTEGER :: ierr, iq, nq
-  IF(test(getKey_sm(keyn, sval, ky, names), lerr)) RETURN
-  nq = SIZE(sval); ALLOCATE(val(nq))
-  DO iq = 1, nq                                                      !--- CONVERT THE KEYS TO INTEGERS
-    READ(sval(iq), *, IOSTAT=ierr) val(iq)
-    IF(test(fmsg('key "'//TRIM(keyn)//'" of tracer "'//TRIM(names(iq))//'" is not a real', modname, ierr/=0), lerr)) RETURN
-  END DO
-  IF(PRESENT(nam)) nam = names
-END FUNCTION getKey_rm
-!==============================================================================================================================
-LOGICAL FUNCTION getKeyByName_l1(keyn, val, tname, ky) RESULT(lerr)
-  USE strings_mod, ONLY: str2bool
-  CHARACTER(LEN=*),          INTENT(IN)  :: keyn
-  LOGICAL,                   INTENT(OUT) :: val
-  CHARACTER(LEN=*),          INTENT(IN)  :: tname
-  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
-!------------------------------------------------------------------------------------------------------------------------------
-  CHARACTER(LEN=maxlen) :: sval
-  lerr = getKeyByName_s1(keyn, sval, tname, ky)
-  IF(test(fmsg('key "'//TRIM(keyn)//'" or tracer "'//TRIM(tname)//'" is missing', modname, lerr), lerr)) RETURN
-  val = str2bool(sval)
-END FUNCTION getKeyByName_l1
-!==============================================================================================================================
-LOGICAL FUNCTION getKeyByName_l1m(keyn, val, tname, ky) RESULT(lerr)
-  USE strings_mod, ONLY: str2bool
-  CHARACTER(LEN=*),           INTENT(IN)  :: keyn
-  LOGICAL,       ALLOCATABLE, INTENT(OUT) :: val(:)
-  CHARACTER(LEN=*),           INTENT(IN)  :: tname
-  TYPE(keys_type),  OPTIONAL, INTENT(IN)  ::  ky(:)
-!------------------------------------------------------------------------------------------------------------------------------
-  CHARACTER(LEN=maxlen), ALLOCATABLE :: sval(:)
-  INTEGER :: iq, nq
-  IF(test(getKeyByName_s1m(keyn, sval, tname, ky), lerr)) RETURN
-  nq = SIZE(sval); ALLOCATE(val(nq))
-  lerr = .FALSE.; DO iq=1, nq; val(iq)=str2bool(sval(iq)); END DO
-END FUNCTION getKeyByName_l1m
-!==============================================================================================================================
-LOGICAL FUNCTION getKeyByName_lm(keyn, val, tname, ky, nam) RESULT(lerr)
-  USE strings_mod, ONLY: str2bool
-  CHARACTER(LEN=*),                             INTENT(IN)  ::  keyn
-  LOGICAL,                         ALLOCATABLE, INTENT(OUT) ::   val(:)
-  CHARACTER(LEN=*),                             INTENT(IN)  :: tname(:)
-  TYPE(keys_type),       OPTIONAL,              INTENT(IN)  ::    ky(:)
-  CHARACTER(LEN=maxlen), OPTIONAL, ALLOCATABLE, INTENT(OUT) ::   nam(:)
-!------------------------------------------------------------------------------------------------------------------------------
-  CHARACTER(LEN=maxlen), ALLOCATABLE :: sval(:)
-  INTEGER :: iq, nq
-  IF(test(getKeyByName_sm(keyn, sval, tname, ky, nam), lerr)) RETURN
-  nq = SIZE(sval); ALLOCATE(val(nq))
-  lerr = .FALSE.; DO iq=1, nq; val(iq)=str2bool(sval(iq)); END DO
-END FUNCTION getKeyByName_lm
-!==============================================================================================================================
-LOGICAL FUNCTION getKey_lm(keyn, val, ky, nam) RESULT(lerr)
-  USE strings_mod, ONLY: str2bool
-  CHARACTER(LEN=*),                             INTENT(IN)  :: keyn
+  REAL,                  OPTIONAL,              INTENT(IN)  ::  def
+  LOGICAL,               OPTIONAL,              INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen) :: s
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: svals(:), tname(:)
+  LOGICAL,               ALLOCATABLE ::    ll(:)
+  IF(     PRESENT(def)) lerr = getKeyByIndex_smmm(keyn, svals, ky, tname, real2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByIndex_smmm(keyn, svals, ky, tname, lDisp=lDisp)
+  IF(lerr) RETURN
+  val = str2real(svals)
+  ll = val == -HUGE(1.)
+  lerr = ANY(ll); IF(.NOT.lerr) THEN; IF(PRESENT(nam)) nam = tname; RETURN; END IF
+  s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(strStack(PACK(tname, MASK=ll)))//' is not a'
+  CALL msg(TRIM(s)//' a real: '//TRIM(strStack(svals, MASK=ll)), modname)
+END FUNCTION getKeyByIndex_rmmm
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByIndex_lmmm(keyn, val, ky, nam, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),                             INTENT(IN)  :: keyn(:)
   LOGICAL,                         ALLOCATABLE, INTENT(OUT) ::  val(:)
   TYPE(keys_type),       OPTIONAL,              INTENT(IN)  ::   ky(:)
   CHARACTER(LEN=maxlen), OPTIONAL, ALLOCATABLE, INTENT(OUT) ::  nam(:)
-!------------------------------------------------------------------------------------------------------------------------------
-  CHARACTER(LEN=maxlen), ALLOCATABLE :: sval(:)
+  LOGICAL,               OPTIONAL,              INTENT(IN)  ::  def
+  LOGICAL,               OPTIONAL,              INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen) :: s
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: svals(:), tname(:)
+  LOGICAL,               ALLOCATABLE ::    ll(:)
+  INTEGER,               ALLOCATABLE :: ivals(:)
+  IF(     PRESENT(def)) lerr = getKeyByIndex_smmm(keyn, svals, ky, tname, bool2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByIndex_smmm(keyn, svals, ky, tname, lDisp=lDisp)
+  IF(lerr) RETURN
+  ivals = str2bool(svals)
+  ll = ivals == -1
+  lerr = ANY(ll); IF(.NOT.lerr) THEN; val = ivals == 1; IF(PRESENT(nam)) nam = tname; RETURN; END IF
+  s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(strStack(tname, MASK=ll))//' is not'
+  CALL msg(TRIM(s)//' a boolean: '//TRIM(strStack(svals, MASK=ll)), modname)
+END FUNCTION getKeyByIndex_lmmm
+!==============================================================================================================================
+
+
+
+!==============================================================================================================================
+!===                                           GET KEYS VALUES FROM TRACERS NAMES                                           ===
+!==============================================================================================================================
+!=== TRY TO GET THE KEY NAMED "key" FOR THE TRACER NAMED "tname" IN:                                                        ===
+!===  * ARGUMENT "ky" DATABASE IF SPECIFIED ; OTHERWISE:                                                                    ===
+!===  * IN INTERNAL TRACERS DATABASE "tracers(:)%keys" (IF UNFOUND, IN INTERNAL ISOTOPES DATABASE "isotope%keys(:)")        ===
+!=== THE RETURNED VALUE (STRING, AN INTEGER, A REAL OR A LOGICAL) CAN BE EITHER:                                            ===
+!===  * A SCALAR                                                                                                            ===
+!===  * A VECTOR, WHICH IS THE FOUND VALUE PARSED WITH THE SEPARATOR ","                                                    ===
+!===                                                                                                                        ===
+!=== SYNTAX:       lerr = getKeyByName_{sirl}{1m}{1m}1(keyn[(:)], val[(:)], tname  [, ky(:)][, def][, lDisp])               ===
+!==============================================================================================================================
+!=== IF "tname(:)" IS A VECTOR, THE RETURNED VALUES (ONE EACH "tname(:)" ELEMENT) ARE STORED IN THE VECTOR "val(:)"         ===
+!===                                                                                                                        ===
+!=== SYNTAX        lerr = getKeyByName_{sirl}{1m}mm   (keyn[(:)], val (:), tname(:)[, ky(:)][, def][, lDisp])               ===
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_s111(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn, tname
+  CHARACTER(LEN=maxlen),     INTENT(OUT) :: val
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  CHARACTER(LEN=*),OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+  lerr = getKeyByName_sm11([keyn], val, tname, ky, def, lDisp)
+END FUNCTION getKeyByName_s111
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_i111(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn, tname
+  INTEGER,                   INTENT(OUT) :: val
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  INTEGER,         OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+  lerr = getKeyByName_im11([keyn], val, tname, ky, def, lDisp)
+END FUNCTION getKeyByName_i111
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_r111(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn, tname
+  REAL   ,                   INTENT(OUT) :: val
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  REAL,            OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+  lerr = getKeyByName_rm11([keyn], val, tname, ky, def, lDisp)
+END FUNCTION getKeyByName_r111
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_l111(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn, tname
+  LOGICAL,                   INTENT(OUT) :: val
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+  lerr = getKeyByName_lm11([keyn], val, tname, ky, def, lDisp)
+END FUNCTION getKeyByName_l111
+!==============================================================================================================================
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_sm11(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn(:), tname
+  CHARACTER(LEN=maxlen),     INTENT(OUT) :: val
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  CHARACTER(LEN=*),OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen) :: s, tnam
+  LOGICAL :: lD
+  lD = .TRUE.; IF(PRESENT(lDisp)) lD = lDisp
+  s = 'key "'//TRIM(strStack(keyn, '/'))//'" for "'//TRIM(tname)//'"'
+  lerr = .TRUE.
+  tnam = strHead(delPhase(tname),'_',.TRUE.)                                             !--- Remove phase and tag
+  IF(lerr .AND. PRESENT(ky))         val = fgetKey(ky)                                   !--- "ky"
+  IF(lerr .AND. ALLOCATED (tracers)) val = fgetKey(tracers(:)%keys)                      !--- "tracers"
+  IF(lerr .AND. ASSOCIATED(isotope)) val = fgetKey(isotope%keys(:))                      !--- "isotope"
+  IF(lerr .AND. PRESENT(def)) THEN
+     val = def; lerr = .NOT.PRESENT(def)
+     CALL msg('Using defaut value of '//TRIM(s)//': '//TRIM(def), modname, lD)
+  END IF
+  CALL msg('No '//TRIM(s)//' or out of bounds index', modname, lD .AND. lerr)
+
+CONTAINS
+
+ CHARACTER(LEN=maxlen) FUNCTION fgetKey(ky) RESULT(val)
+  TYPE(keys_type),  INTENT(IN)  :: ky(:)
+  lerr = SIZE(ky) == 0
+  IF(lerr) RETURN
+           val = fgetKeyIdx(strIdx(ky%name, tname), [keyn], ky, lerr)
+  IF(lerr) val = fgetKeyIdx(strIdx(ky%name, tnam ), [keyn], ky, lerr)
+
+END FUNCTION fgetKey
+
+END FUNCTION getKeyByName_sm11
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_im11(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn(:), tname
+  INTEGER,                   INTENT(OUT) :: val
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  INTEGER,         OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen) :: sval, s
+  IF(     PRESENT(def)) lerr = getKeyByName_sm11(keyn, sval, tname, ky, int2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByName_sm11(keyn, sval, tname, ky, lDisp=lDisp)
+  IF(lerr) RETURN
+  val = str2int(sval)
+  lerr = val == -HUGE(1)
+  s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(tname)//' is not'
+  CALL msg(TRIM(s)//' an integer: '//TRIM(sval), modname, lerr)
+END FUNCTION getKeyByName_im11
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_rm11(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn(:), tname
+  REAL   ,                   INTENT(OUT) :: val
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  REAL,            OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen) :: sval, s
+  IF(     PRESENT(def)) lerr = getKeyByName_sm11(keyn, sval, tname, ky, real2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByName_sm11(keyn, sval, tname, ky, lDisp=lDisp)
+  IF(lerr) RETURN
+  val = str2real(sval)
+  lerr = val == -HUGE(1.)
+  s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(tname)//' is not'
+  CALL msg(TRIM(s)//' a real: '//TRIM(sval), modname, lerr)
+END FUNCTION getKeyByName_rm11
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_lm11(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn(:), tname
+  LOGICAL,                   INTENT(OUT) :: val
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen) :: sval, s
+  INTEGER               :: ival
+  IF(     PRESENT(def)) lerr = getKeyByName_sm11(keyn, sval, tname, ky, bool2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByName_sm11(keyn, sval, tname, ky, lDisp=lDisp)
+  IF(lerr) RETURN
+  ival = str2bool(sval)
+  lerr = ival == -1
+  s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(tname)//' is not'
+  CALL msg(TRIM(s)//' a boolean: '//TRIM(sval), modname, lerr)
+  IF(.NOT.lerr) val = ival == 1
+END FUNCTION getKeyByName_lm11
+!==============================================================================================================================
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_s1m1(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),                   INTENT(IN)  :: keyn, tname
+  CHARACTER(LEN=maxlen), ALLOCATABLE, INTENT(OUT) :: val(:)
+  TYPE(keys_type),          OPTIONAL, INTENT(IN)  :: ky(:)
+  CHARACTER(LEN=*),         OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,                  OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen)              :: sval
+  lerr = getKeyByName_sm11([keyn], sval, tname, ky, def, lDisp); IF(lerr) RETURN
+  lerr = strParse(sval, ',', val)
+  IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
+END FUNCTION getKeyByName_s1m1
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_i1m1(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn, tname
+  INTEGER,      ALLOCATABLE, INTENT(OUT) :: val(:)
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  INTEGER,         OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen)              :: sval, s
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: svals(:)
+  IF(     PRESENT(def)) lerr = getKeyByName_sm11([keyn], sval, tname, ky, int2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByName_sm11([keyn], sval, tname, ky, lDisp=lDisp)
+  IF(lerr) RETURN
+  lerr = strParse(sval, ',', svals)
+  IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
+  val = str2int(svals)
+  lerr = ANY(val == -HUGE(1))
+  s = 'key "'//TRIM(keyn)//'" of '//TRIM(tname)//' is not'
+  CALL msg(TRIM(s)//' an integer: '//TRIM(sval), modname, lerr)
+END FUNCTION getKeyByName_i1m1
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_r1m1(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn, tname
+  REAL,         ALLOCATABLE, INTENT(OUT) :: val(:)
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  REAL,            OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen)              :: sval, s
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: svals(:)
+  IF(     PRESENT(def)) lerr = getKeyByName_sm11([keyn], sval, tname, ky, real2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByName_sm11([keyn], sval, tname, ky, lDisp=lDisp)
+  IF(lerr) RETURN
+  lerr = strParse(sval, ',', svals)
+  IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
+  val = str2real(svals)
+  lerr = ANY(val == -HUGE(1.))
+  s = 'key "'//TRIM(keyn)//'" of '//TRIM(tname)//' is not'
+  CALL msg(TRIM(s)//' a real: '//TRIM(sval), modname, lerr)
+END FUNCTION getKeyByName_r1m1
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_l1m1(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn, tname
+  LOGICAL,      ALLOCATABLE, INTENT(OUT) :: val(:)
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen)              :: sval, s
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: svals(:)
+  INTEGER,               ALLOCATABLE :: ivals(:)
+  IF(     PRESENT(def)) lerr = getKeyByName_sm11([keyn], sval, tname, ky, bool2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByName_sm11([keyn], sval, tname, ky, lDisp=lDisp)
+  IF(lerr) RETURN
+  lerr = strParse(sval, ',', svals)
+  IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
+  ivals = str2bool(svals)
+  lerr = ANY(ivals == -1)
+  s = 'key "'//TRIM(keyn)//'" of '//TRIM(tname)//' is not'
+  CALL msg(TRIM(s)//' a boolean: '//TRIM(sval), modname, lerr)
+  IF(.NOT.lerr) val = ivals == 1
+END FUNCTION getKeyByName_l1m1
+!==============================================================================================================================
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_smm1(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),                   INTENT(IN)  :: keyn(:), tname
+  CHARACTER(LEN=maxlen), ALLOCATABLE, INTENT(OUT) :: val(:)
+  TYPE(keys_type),          OPTIONAL, INTENT(IN)  :: ky(:)
+  CHARACTER(LEN=*),         OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,                  OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen) :: sval
+  lerr = getKeyByName_sm11(keyn, sval, tname, ky, def, lDisp); IF(lerr) RETURN
+  lerr = strParse(sval, ',', val)
+  IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
+END FUNCTION getKeyByName_smm1
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_imm1(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn(:), tname
+  INTEGER,      ALLOCATABLE, INTENT(OUT) :: val(:)
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  INTEGER,         OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen)              :: sval, s
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: svals(:)
+  IF(     PRESENT(def)) lerr = getKeyByName_sm11(keyn, sval, tname, ky, int2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByName_sm11(keyn, sval, tname, ky, lDisp=lDisp)
+  IF(lerr) RETURN
+  lerr = strParse(sval, ',', svals)
+  IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
+  val = str2int(svals)
+  lerr = ANY(val == -HUGE(1))
+  s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(tname)//' is not'
+  CALL msg(TRIM(s)//' an integer: '//TRIM(sval), modname, lerr)
+END FUNCTION getKeyByName_imm1
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_rmm1(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn(:), tname
+  REAL,         ALLOCATABLE, INTENT(OUT) :: val(:)
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  REAL,            OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen)              :: sval, s
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: svals(:)
+  IF(     PRESENT(def)) lerr = getKeyByName_sm11(keyn, sval, tname, ky, real2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByName_sm11(keyn, sval, tname, ky, lDisp=lDisp)
+  IF(lerr) RETURN
+  lerr = strParse(sval, ',', svals)
+  IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
+  val = str2real(svals)
+  lerr = ANY(val == -HUGE(1.))
+  s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(tname)//' is not'
+  CALL msg(TRIM(s)//' a real: '//TRIM(sval), modname, lerr)
+END FUNCTION getKeyByName_rmm1
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_lmm1(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn(:), tname
+  LOGICAL,      ALLOCATABLE, INTENT(OUT) :: val(:)
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen)              :: sval, s
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: svals(:)
+  INTEGER,               ALLOCATABLE :: ivals(:)
+  IF(     PRESENT(def)) lerr = getKeyByName_sm11(keyn, sval, tname, ky, bool2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByName_sm11(keyn, sval, tname, ky, lDisp=lDisp)
+  IF(lerr) RETURN
+  lerr = strParse(sval, ',', svals)
+  IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
+  ivals = str2bool(svals)
+  lerr = ANY(ivals == -1)
+  s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(tname)//' is not'
+  CALL msg(TRIM(s)//' a boolean: '//TRIM(sval), modname, lerr)
+  IF(.NOT.lerr) val = ivals == 1
+END FUNCTION getKeyByName_lmm1
+!==============================================================================================================================
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_s1mm(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),                   INTENT(IN)  :: keyn, tname(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE, INTENT(OUT) :: val(:)
+  TYPE(keys_type),       OPTIONAL,    INTENT(IN)  ::  ky(:)
+  CHARACTER(LEN=*),      OPTIONAL,    INTENT(IN)  :: def
+  LOGICAL,               OPTIONAL,    INTENT(IN)  :: lDisp
+  lerr = getKeyByName_smmm([keyn], val, tname, ky, def, lDisp)
+END FUNCTION getKeyByName_s1mm
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_i1mm(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn, tname(:)
+  INTEGER,      ALLOCATABLE, INTENT(OUT) :: val(:)
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  ::  ky(:)
+  INTEGER,         OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+  lerr = getKeyByName_immm([keyn], val, tname, ky, def, lDisp)
+END FUNCTION getKeyByName_i1mm
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_r1mm(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn, tname(:)
+  REAL,         ALLOCATABLE, INTENT(OUT) :: val(:)
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  ::  ky(:)
+  REAL,            OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+  lerr = getKeyByName_rmmm([keyn], val, tname, ky, def, lDisp)
+END FUNCTION getKeyByName_r1mm
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_l1mm(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn, tname(:)
+  LOGICAL,      ALLOCATABLE, INTENT(OUT) :: val(:)
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  ::  ky(:)
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+  lerr = getKeyByName_lmmm([keyn], val, tname, ky, def, lDisp)
+END FUNCTION getKeyByName_l1mm
+!==============================================================================================================================
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_smmm(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),                   INTENT(IN)  :: keyn(:), tname(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE, INTENT(OUT) ::  val(:)
+  TYPE(keys_type),       OPTIONAL,    INTENT(IN)  ::   ky(:)
+  CHARACTER(LEN=*),      OPTIONAL,    INTENT(IN)  ::   def
+  LOGICAL,               OPTIONAL,    INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen) :: s
   INTEGER :: iq, nq
-  IF(test(getKey_sm(keyn, sval, ky, nam), lerr)) RETURN
-  nq = SIZE(sval); ALLOCATE(val(nq))
-  lerr = .FALSE.; DO iq=1, nq; val(iq)=str2bool(sval(iq)); END DO
-END FUNCTION getKey_lm
+  LOGICAL :: lD
+  nq = SIZE(tname); ALLOCATE(val(nq))
+  lD = .TRUE.; IF(PRESENT(lDisp)) lD = lDisp
+  s = 'key "'//TRIM(strStack(keyn, '/'))//'"'
+  lerr = .TRUE.
+  IF(PRESENT(ky)) THEN;                 val = fgetKey(ky)                                !--- "ky"
+  ELSE IF(ALLOCATED(tracers)) THEN;     val = fgetKey(tracers(:)%keys)                   !--- "tracers"
+     IF(lerr .AND. ASSOCIATED(isotope)) val = fgetKey(isotope%keys(:))                   !--- "isotope"
+  END IF
+  IF(.NOT.PRESENT(def)) THEN; CALL msg('No '//TRIM(s)//' found', modname, lD); RETURN; END IF
+
+  !--- DEFAULT VALUE
+  val = [(def, iq = 1, SIZE(tname))]
+  CALL msg('Using defaut value for '//TRIM(s)//': '//TRIM(def), modname, lD)
+
+CONTAINS
+
+FUNCTION fgetKey(ky) RESULT(val)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: val(:)
+  TYPE(keys_type),       INTENT(IN)  :: ky(:)
+  LOGICAL,               ALLOCATABLE :: ler(:)
+  lerr = SIZE(ky) == 0; IF(lerr) RETURN
+  ALLOCATE(ler(SIZE(tname)))
+  val = [(fgetKeyIdx(strIdx(ky(:)%name, tname(iq)), keyn, ky, ler(iq)), iq = 1, SIZE(tname))]
+  lerr = ANY(ler)
+END FUNCTION fgetKey
+
+END FUNCTION getKeyByName_smmm
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_immm(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn(:), tname(:)
+  INTEGER,      ALLOCATABLE, INTENT(OUT) ::  val(:)
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  ::   ky(:)
+  INTEGER,         OPTIONAL, INTENT(IN)  ::  def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen) :: s
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: svals(:)
+  LOGICAL,               ALLOCATABLE ::    ll(:)
+  IF(     PRESENT(def)) lerr = getKeyByName_smmm(keyn, svals, tname, ky, int2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByName_smmm(keyn, svals, tname, ky, lDisp=lDisp)
+  IF(lerr) RETURN
+  val = str2int(svals)
+  ll = val == -HUGE(1)
+  lerr = ANY(ll); IF(.NOT.lerr) RETURN
+  s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(strStack(tname, MASK=ll))//' is not'
+  CALL msg(TRIM(s)//' an integer: '//TRIM(strStack(svals, MASK=ll)), modname)
+END FUNCTION getKeyByName_immm
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_rmmm(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn(:), tname(:)
+  REAL,         ALLOCATABLE, INTENT(OUT) ::  val(:)
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  ::   ky(:)
+  REAL,            OPTIONAL, INTENT(IN)  ::  def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen) :: s
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: svals(:)
+  LOGICAL,               ALLOCATABLE ::    ll(:)
+  IF(     PRESENT(def)) lerr = getKeyByName_smmm(keyn, svals, tname, ky, real2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByName_smmm(keyn, svals, tname, ky, lDisp=lDisp)
+  IF(lerr) RETURN
+  val = str2real(svals)
+  ll = val == -HUGE(1.)
+  lerr = ANY(ll); IF(.NOT.lerr) RETURN
+  s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(strStack(tname, MASK=ll))//' is not'
+  CALL msg(TRIM(s)//' a real: '//TRIM(strStack(svals, MASK=ll)), modname)
+END FUNCTION getKeyByName_rmmm
+!==============================================================================================================================
+LOGICAL FUNCTION getKeyByName_lmmm(keyn, val, tname, ky, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn(:), tname(:)
+  LOGICAL,      ALLOCATABLE, INTENT(OUT) ::  val(:)
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  ::   ky(:)
+  LOGICAL,         OPTIONAL, INTENT(IN)  ::  def
+  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen) :: s
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: svals(:)
+  LOGICAL,               ALLOCATABLE ::    ll(:)
+  INTEGER,               ALLOCATABLE :: ivals(:)
+  IF(     PRESENT(def)) lerr = getKeyByName_smmm(keyn, svals, tname, ky, bool2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByName_smmm(keyn, svals, tname, ky, lDisp=lDisp)
+  IF(lerr) RETURN
+  ivals = str2bool(svals)
+  ll = ivals == -1
+  lerr = ANY(ll); IF(.NOT.lerr) THEN; val = ivals == 1; RETURN; END IF
+  s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(strStack(tname, MASK=ll))//' is not'
+  CALL msg(TRIM(s)//' a boolean: '//TRIM(strStack(svals, MASK=ll)), modname)
+END FUNCTION getKeyByName_lmmm
 !==============================================================================================================================
 
